# coding: utf-8

import json

from common.sysfunctions import toHexForXml, getGridHeight
from edu._edu_orm import vw_courseCursor, courseCursor,course_edu_formCursor, course_edu_baseCursor, course_contingentCursor
from nci._nci_orm import person_edu_organizationCursor, education_formCursor, education_baseCursor, edu_organizationCursor,\
status_listCursor
from umk._umk_orm import specialityCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from security.functions import userHasPermission
from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid
from gridsettings.functions.gridSettings import toolbar_button_default,filter_button, toolbar_button, filter_reset_button, get_column_meta,\
                                                 get_column_data, get_column_header
from gridsettings._gridsettings_orm import grid_fieldCursor, user_grid_fieldCursor
try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO


def gridData(context, main, add=None, filterinfo=None, session=None, elementId=None,
             sortColumnList=None, firstrecord=None, pagesize=None):    
    session = json.loads(session)
    sid = session['sessioncontext']['sid']
    course = vw_courseCursor(context)
    course_edu_form = course_edu_formCursor(context)
    edu_form = education_formCursor(context)
    course_edu_base = course_edu_baseCursor(context)
    edu_base = education_baseCursor(context)
    speciality = specialityCursor(context)
    course_contingent = course_contingentCursor(context)
    status_list = status_listCursor(context)
    grid_field = grid_fieldCursor(context)
    user_grid_field = user_grid_fieldCursor(context)
    
    if sortColumnList:
        sortName = toHexForXml(sortColumnList[0].id)
        sortType = unicode(sortColumnList[0].sorting).lower()
    else:
        sortName = None

    _header = {'uid': ['~~id', 'uid'],
        'properties': [u'properties', 'properties']}

    _header.update(get_column_header(grid_field,user_grid_field,elementId,sid))

#     course.orderBy('speciality_name', 'name')
    if context.getData().get('courseFilter',''):
        ext_filter(context.getData()['courseFilter'],course,context)        
     
    for column in _header:
        _header[column].append(toHexForXml(_header[column][0]))
        if column != "edu_form" and column != "base":
            if sortName == _header[column][-1]:
                course.orderBy("%s %s" % (column, sortType))

    if not userHasPermission(context, sid, "allEduOrgCourse"):
        person_org = person_edu_organizationCursor(context)
        person_org.setRange("person_id", getPersonIdBySid(context, sid))
        if not person_org.count():
            context.error(u"Обратитесь к администратору для приписывания к образовательной организации")
        edu_list = []
        for person_org in person_org.iterate():
            edu_list.append("'%s'" % person_org.edu_organization_id)
        course.setFilter("edu_organization_id", "|".join(edu_list))
        course.setFilter('status_id', '!8')

    course.limit(firstrecord - 1, pagesize)

    grid_data = {'records': {'rec': []}}
     
    count = 1
    u"""Заполнение полей грида"""
    for course in course.iterate():
        u"""Название формы обучения"""
        edu_form_name = ""
        
        u"""Получение названия формы обучения"""
        course_edu_form.setRange("course_id",course.uid)
        for form in course_edu_form.iterate():
            edu_form.get(form.edu_form_id)
            edu_form_name += edu_form.name + ", "
        edu_form_name = edu_form_name[:-2]#отсечение последней запятой и пробела
        
        u"""Название основы обучения"""
        edu_base_name = ""
        u"""Получение названия основы обучения"""
        course_edu_base.setRange("course_id",course.uid)
        for base in course_edu_base.iterate():
            edu_base.get(base.edu_base_id)
            edu_base_name += edu_base.name + ", "
        edu_base_name = edu_base_name[:-2]#отсечение последней запятой и пробела
        
        u"""Набор дополнительных специальностей"""
        contingent_str = ""
        u"""Получение набора дополнительных специальностей в виде строки"""
        course_contingent.setRange("course_id",course.uid)
        for contingent in course_contingent.iterate():
            speciality.get(contingent.speciality_id)
            contingent_str += speciality.name + ", "
        contingent_str = contingent_str[:-2]#отсечение последней запятой и пробела
        
        u"""Наименование статуса"""
        status_name = ""
        u"""Получение наименования статуса"""
        status_list.get(course.status_id)
        status_name = status_list.name
        
        u"""Формирование заготовки для активной ссылки"""
        add_info = {"contingent":contingent_str,
                    "edu_form":edu_form_name,
                    "program_link":{"div":{"a":{ 
                                         "@href": course.program_link,
                                         "@target":"_blank",
                                          "#text":course.program_link                                       
                                         }
                                    }} if course.program_link else '',
                    "base":edu_base_name,
                    "status_name": status_name,
                    "info":{'div':{'ins':{'font':{ "@style": "cursor: pointer",
                                                    "@title": u"Отобразить подробную информацию о программе",
                                                    '@color':'blue',
                                                        '#text':u'Подробнее'}}}}
                    }
                                    
        row = {}

        row[_header['uid'][2]] = course.uid
        get_column_data(_header, grid_field, user_grid_field, elementId, sid, course, row,**add_info)


        row[_header['properties'][2]] = {'event': [   
                    {'@name': 'row_single_click',
                     'action': {
                        '#sorted': [
                            {'main_context': 'current'},
                            {'datapanel': {
                                '@type': 'current',
                                '@tab': 'current',
                                "element": [ 
                                    {"@id": "courseCycleFilter",
                                     "add_context": ''},]}}]}},
                    {'@name': 'cell_single_click',
                     '@column': _header.get('info',[' '])[0],
                     'action': {
                        '@show_in': 'MODAL_WINDOW',
                        '#sorted': [
                            {'main_context': 'current'},
                            {'modalwindow': {
                                '@caption': u'Сведения о программе',
                                '@height': '570',
                                '@width': '660'}},
                                {'datapanel': {
                                    '@type': 'current',
                                    '@tab': 'current',
                                    'element': {
                                        '@id': 'courseCardInfo',
                                        'add_context': 'infoCard'}}}]}}]}        
        
        grid_data['records']['rec'].append(row)

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(grid_data)),None)


def gridMeta(context, main=None, add=None, filterinfo=None, session=None, elementId=None,
             sortColumnList=None):
    session = json.loads(session)
    sid = session["sessioncontext"]["sid"]
    course = vw_courseCursor(context)

    if not userHasPermission(context, sid, "allEduOrgCourse"):
        person_org = person_edu_organizationCursor(context)
        person_org.setRange("person_id", getPersonIdBySid(context, sid))
        if not person_org.count():
            context.error(u"Обратитесь к администратору для приписывания к образовательной организации")
        edu_list = []
        for person_org in person_org.iterate():
            edu_list.append("'%s'" % person_org.edu_organization_id)
        course.setFilter("edu_organization_id", "|".join(edu_list))
    filter_string = ''
    if context.getData().get('courseFilter',''):
        filter_string = ext_filter(context.getData()['courseFilter'],course,context)
    grid_settings = {}
    grid_settings['gridsettings'] = {'labels': {
            'header': 'Программы ПК ' + filter_string},
            'columns': { 
                'col': get_column_meta(context,elementId,sid)},
            'properties': {
                '@pagesize': 50,
                '@gridWidth': '100%',
                '@gridHeight': getGridHeight(session, numberOfGrids=1, gridHeaderHeight=15, delta=230),
                '@totalCount': course.count(),
                '@profile': 'default_excel.properties'}}

    return JythonDTO(None,XMLJSONConverter.jsonToXml(json.dumps(grid_settings)))


def gridToolBar(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    course = courseCursor(context)
    session_json = json.loads(session)['sessioncontext']
    sid = session_json['sid']
    grid_context = session_json['related']['gridContext']
    string_bool = lambda x: x and 'true' or 'false'

    if "currentRecordId" in grid_context:
        current_id = grid_context["currentRecordId"]
        course.get(current_id) 
        change_style = edit_style = string_bool(False)
    else:
        current_id = ''
        change_style = edit_style = string_bool(True)
    # добавление курса
    if userHasPermission(context, session_json['sid'], 'addCourse'):
        add_style = string_bool(False)
    else:
        add_style = string_bool(True)
    # редактирование курса
    u"""Методисту запрещено изменять программы со статусом 'Формируется' и 'На доработке'"""
    if userHasPermission(context, session_json['sid'], 'allEduOrgCourse') and (course.status_id == 0 or course.status_id == 1):
        change_style = edit_style = string_bool(True)

    elif not userHasPermission(context, session_json['sid'], 'allEduOrgCourse') and \
    (course.status_id != 0 and course.status_id != 1):
        u"""Образовательная организация может редактировать
        только программы со статусом 'Формируется' и 'на доработке'"""
        change_style = edit_style = string_bool(True)
    # удаление курса
    if userHasPermission(context, session_json['sid'], 'delCourse'):
        delete_style = edit_style
    else:
        delete_style = string_bool(True)

    grid_toolbar = {
        'gridtoolbar': {
            '#sorted': [
                 toolbar_button(context, sid, elementId),
                 toolbar_button_default(context, sid, elementId),
                 filter_button("courseFilter",270,630),    
                 filter_reset_button("courseGrid","courseFilter"),
                {'item': {
                    '@text': u'Добавить',
                    '@hint': u'Добавить программу',
                    '@disable': add_style,
                    'action': {
                        '@show_in': 'MODAL_WINDOW',
                        '#sorted': [
                            {'main_context': 'current'},
                            {'modalwindow': {
                                '@caption': u'Добавить программу',
                                '@height': '570',
                                '@width': '660'}},
                            {'datapanel': {
                                '@type': 'current',
                                '@tab': 'current',
                                'element': {
                                    '@id': 'courseCard',
                                    'add_context': 'add'}}}]}}},
                {'item': {
                    '@text': u'Редактировать',
                    '@hint': u'Редактировать программу',
                    '@disable': edit_style,
                    'action': {
                        '@show_in': 'MODAL_WINDOW',
                        '#sorted': [
                            {'main_context': 'current'},
                            {'modalwindow': {
                                '@caption': u'Редактировать программу',
                                '@height': '570',
                                '@width': '660'}},
                            {'datapanel': {
                                '@type': 'current',
                                '@tab': 'current',
                                'element': {
                                    '@id': 'courseCard',
                                    'add_context': 'edit'}}}]}}},
                {'item': {
                    '@text': u'Удалить',
                    '@hint': u'Удалить программу',
                    '@disable': delete_style,
                    'action': {
                        '@show_in': 'MODAL_WINDOW',
                        '#sorted': [
                            {'main_context': 'current'},
                            {'modalwindow': {
                                '@caption': u'Удалить программу',
                                '@height': '145',
                                '@width': '400'}},
                            {'datapanel': {
                                '@type': 'current',
                                '@tab': 'current',
                                'element': {
                                    '@id': 'courseDeleteCard',
                                    'add_context': ''}}}]}}},                        
                {'item': {
                    '@text': u'Изменить статус',
                    '@hint': u'Изменить статус',
                    '@disable': change_style,
                    'action': {
                        '@show_in': 'MODAL_WINDOW',
                        '#sorted': [
                            {'main_context': 'current'},
                            {'modalwindow': {
                                '@caption': u'Изменение статуса',
                                '@height': '150',
                                '@width': '440'}},
                            {'datapanel': {
                                '@type': 'current',
                                '@tab': 'current',
                                'element': {
                                    '@id': 'courseChangeStatusCard',
                                    'add_context': ''}}}]}}},
                {'item': {
                    '@text': u'Открыть',
                    '@hint': u'Открыть программу',
                    '@disable': edit_style,
                    'action': {
                        '#sorted': [
                            {'main_context': 'current'},
                            {'navigator': {
                                '@element': 'certificate-{}'.format(current_id),
                                '@refresh': 'true'}},
                            {'server' : {
                                'activity' : {
                                    '@id': "addOpenedCource", 
                                    '@name': "edu.server.serverAction.addOpenedCource.celesta",
                                    'add_context': current_id}}}]}}}]}}

    return XMLJSONConverter.jsonToXml(json.dumps(grid_toolbar))


def ext_filter(session,course,context):
    edu_organization = edu_organizationCursor(context)
    status_list = status_listCursor(context)
    filter_string = u"Фильтр: "
    filter_list = []
    whereclause = '1 = 1'
    def str2bool(str):
        if str == 'false':
            return False
        elif str == 'true':
            return True
        else:
            return False
        
    if True:#'formData' in session['related']['xformsContext']:
#         data = session['related']['xformsContext']['formData']['schema']['record']
        data = session['schema']['record']
        status_id = data["status_id"]
        name = data['name']
        speciality_id = data['speciality_id']
        speciality_name = data['speciality_name']
        edu_org_id = data['edu_organization_id']
        edu_org_name = data['edu_organization_name']
        dot_and_eo = data['dot_and_eo']
        certification = data['certificate']
        simulation = data['simulation']
        intern = data['intern']
        dev_year = data['dev_year']
        sim_hours_from = data['sim_hours_from']
        sim_hours_to = data['sim_hours_to']
        intern_hours_from = data['intern_hours_from']
        intern_hours_to = data['intern_hours_to']
        hours_from = data['hours_from']
        hours_to = data['hours_to']

        course.setFilter('name',"@%%'%s'%%"%(name))
        if status_id and status_id != '-':
            status_list.get(status_id)
            filter_list.append(u"статус: %s" %(status_list.name))
            course.setRange("status_id",status_id)
        if name:
            filter_list.append(u'название содержит %s'%(name))
        if speciality_id:
            filter_list.append(u'специальность: %s'%(speciality_name))
            course.setRange('speciality_id',speciality_id)
        if edu_org_id and edu_org_id != '-':
            edu_organization.get(edu_org_id)
            filter_list.append(u'образовательная организация: %s'%(edu_organization.abbreviation))
            course.setRange('edu_organization_id',edu_org_id)
        if dot_and_eo != '-':
            filter_list.append(u"ДОТ и ЭО: %s"%(u'Да' if str2bool(dot_and_eo) else u'Нет'))
            course.setRange('dot_and_eo',str2bool(dot_and_eo))
        if simulation != '-':
            filter_list.append(u"cимуляционное обучение: %s"%(u'Да' if str2bool(simulation) else u'Нет'))
            course.setRange('osk',str2bool(simulation))
        if intern != '-':
            filter_list.append(u"cтажировка: %s"%(u'Да' if str2bool(intern) else u'Нет'))
            course.setRange('internship',str2bool(intern))
        if certification != '-':
            filter_list.append(u"сертификационная: %s"%(u'Да' if str2bool(certification) else u'Нет'))
            course.setRange('isCertification',str2bool(certification))
        if dev_year != '':
            filter_list.append(u"год разработки: %s"%(dev_year))
            course.setRange('dev_year', int(dev_year))
        if hours_from and hours_to:
            filter_list.append(u"академических часов с %s по %s"%(hours_from,hours_to))
            course.setRange('course_hours',float(hours_from), float(hours_to))
        elif hours_from:
            filter_list.append(u"академических часов с %s"%(hours_from))
            course.setFilter('course_hours', '%s..' % hours_from)
        elif hours_to:
            filter_list.append(u"академических часов по %s"%(hours_to))
            course.setFilter('course_hours', '..%s' % hours_to)
        if sim_hours_from and sim_hours_to:
            filter_list.append(u"объём сим. обучения с %s по %s"%(sim_hours_from,sim_hours_to))
            course.setRange('osk_hours',float(sim_hours_from), float(sim_hours_to))
        elif sim_hours_from:
            filter_list.append(u"объём сим. обучения с %s"%(sim_hours_from))
            course.setFilter('osk_hours', '%s..' % sim_hours_from)
        elif sim_hours_to:
            filter_list.append(u"объём сим. обучения по %s"%(sim_hours_to))
            course.setFilter('osk_hours', '..%s' % sim_hours_to)
        if intern_hours_from and intern_hours_to:
            filter_list.append(u"часов стажировки с %s по %s"%(intern_hours_from,intern_hours_to))
            course.setRange('internship_hours',float(intern_hours_from), float(intern_hours_to))
        elif intern_hours_from:
            filter_list.append(u"часов стажировки с %s"%(intern_hours_from))
            course.setFilter('internship_hours', '%s..' % intern_hours_from)
        elif intern_hours_to:
            filter_list.append(u"часов стажировки по %s"%(intern_hours_to))
            course.setFilter('internship_hours', '..%s' % intern_hours_to)
                  
    course.setComplexFilter(whereclause)
    filter_string = '<b>' + filter_string + ','.join(filter_list) +'</b>'
    return filter_string