# coding: utf-8
'''
Created on 04.06.2014

@author: Victor B.
'''
#                                                                      not ended !!!!!
import datetime
from java.io import FileOutputStream
from java.text import SimpleDateFormat
import json

from edu._edu_orm import vw_courseCursor, course_cycleCursor, \
    course_edu_formCursor
from edu.reports.printExcelReports import printToExcel
from nci._nci_orm import education_formCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import specialityCursor


#try:
#    from ru.curs.showcase.util import XMLJSONConverter as XMLJSONConverter2
#except:
#    from ru.curs.celesta.showcase.utils import XMLJSONConverter as XMLJSONConverter2
try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
    from ru.curs.showcase.core import UserMessage
    from ru.curs.showcase.app.api import MessageType
except:
    from ru.curs.celesta.showcase import JythonDTO



def reportData(context):
    u'''Отчет по внебюджетным слушателям (по зачислению)'''

    speciality = specialityCursor(context)
    vw_course = vw_courseCursor(context)
    course_edu_form = course_edu_formCursor(context)
    education_form = education_formCursor(context)
    course_cycle = course_cycleCursor(context)
    speciality.setRange('education_level', 4)
    speciality.orderBy('name')
    sdf = SimpleDateFormat('dd.MM.yyyy')
    
    data = {"schema":
            {"speciality":
             [],
             'date':sdf.format(datetime.datetime.now())
            }
        }
    
    count_spec = 1
    for speciality in speciality.iterate():
        count_program = 1
        spec_dict = {"name":speciality.name,
                     "number":count_spec,
                     "program":''
                     }
        program_list = []
        vw_course.setRange('speciality_id',speciality.uid)
        vw_course.orderBy('edu_organization_name')
        for course in vw_course.iterate():
            course_cycle.setRange('course_id',course.uid)
            edu_forms = []
            course_edu_form.setRange('course_id', course.uid)
            for course_edu_form in course_edu_form.iterate():
                education_form.get(course_edu_form.edu_form_id)
                edu_forms.append(education_form.name)
            
            program_dict = {'number':'%d.%d' % (count_spec,count_program),
                            'edu_org_name':course.edu_organization_name,
                            'name':course.name,
                            'type':u'ПК',
                            'edu_forms': ','.join(edu_forms),
                            'internship':u'Да' if course.internship else u'Нет',
                            'simulation':u'Да' if course.osk else u'Нет',
                            'dot_eo':u'Да' if course.dot_and_eo else u'Нет',
                            'zet':course.course_hours if course.course_hours else '',
                            'zet_internship':course.internship_hours if course.internship_hours else '',
                            'zet_simulation':course.osk_hours if course.osk_hours else '',
                            'cycles_number':course_cycle.count(),
                            'edu_cost':course.edu_cost
                            }
            count_program += 1
            program_list.append(program_dict)
        spec_dict['program'] = program_list
        if program_list:
            count_spec += 1
            data['schema']['speciality'].append(spec_dict)


    xmlData = XMLJSONConverter.jsonToXml(json.dumps(data))
    return (u'<?xml version="1.0" encoding="UTF-8"?> %s' % xmlData)


def consolidateReportData(context):
    u'''Отчет по внебюджетным слушателям (по зачислению)'''

    speciality = specialityCursor(context)
    vw_course = vw_courseCursor(context)
    course_edu_form = course_edu_formCursor(context)
    education_form = education_formCursor(context)
    course_cycle = course_cycleCursor(context)
    speciality.setRange('education_level', 4)
    speciality.orderBy('name')
    sdf = SimpleDateFormat('dd.MM.yyyy')
    
    data = {"schema":
            {"speciality":
             [],
             'date':sdf.format(datetime.datetime.now())
            }
        }
    
    count_spec = 1
    for speciality in speciality.iterate():
        spec_dict = {"name":speciality.name,
                     "number":count_spec,
                     
                     }
        edu_org_ids = set()
        vw_course.setRange('speciality_id',speciality.uid)
        vw_course.orderBy('edu_organization_name')
        
        spec_dict['program_count'] = vw_course.count()
        vw_course.setRange('internship',True)
        spec_dict['program_internship_count'] = vw_course.count()
        vw_course.setRange('internship')
        
        vw_course.setRange('osk',True)
        spec_dict['program_osk_count'] = vw_course.count()
        vw_course.setRange('osk')
        
        vw_course.setRange('dot_and_eo',True)
        spec_dict['program_dot_eo_count'] = vw_course.count()
        vw_course.setRange('dot_and_eo')
        
        for course in vw_course.iterate():
            if course.edu_organization_id not in edu_org_ids:
                edu_org_ids.add(course.edu_organization_id)
        spec_dict['edu_org_count'] = len(edu_org_ids)
        count_spec += 1
        data['schema']['speciality'].append(spec_dict)


    xmlData = XMLJSONConverter.jsonToXml(json.dumps(data))
    return (u'<?xml version="1.0" encoding="UTF-8"?> %s' % xmlData)


def printToFlute(context, params):
    u'''Функция для подготовки печатных форм через флейту.
    '''

    arg_dict = json.loads(params.params)
    data = reportData(context)
    # печатаем в resultstream флейты
    printToExcel(data, 'specialityReport.xls', 'specialityReport.xml', params.resultstream)

def printConsolidateToFlute(context, params):
    u'''Функция для подготовки печатных форм через флейту.
    '''

    arg_dict = json.loads(params.params)
    data = consolidateReportData(context)
    # печатаем в resultstream флейты
    printToExcel(data, 'consolidateSpecialityReport.xls', 'consolidateSpecialityReport.xml', params.resultstream)