# coding: utf-8
'''
Created on 04.06.2014

@author: Victor B.
'''
#                                                                      not ended !!!!!
import datetime
from java.io import FileOutputStream
from java.text import SimpleDateFormat
import json

from edu._edu_orm import vw_courseCursor, course_cycleCursor, \
    course_edu_formCursor
from edu.reports.printExcelReports import printToExcel
from nci._nci_orm import education_formCursor, edu_organizationCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import specialityCursor
from medstaff._medstaff_orm import student_certificateCursor

#try:
#    from ru.curs.showcase.util import XMLJSONConverter as XMLJSONConverter2
#except:
#    from ru.curs.celesta.showcase.utils import XMLJSONConverter as XMLJSONConverter2
try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
    from ru.curs.showcase.core import UserMessage
    from ru.curs.showcase.app.api import MessageType
except:
    from ru.curs.celesta.showcase import JythonDTO


#try:
#    from ru.curs.showcase.util import XMLJSONConverter as XMLJSONConverter2
#except:
#    from ru.curs.celesta.showcase.utils import XMLJSONConverter as XMLJSONConverter2
def reportData(context, edu_org_id, date_from, date_to):
    u'''Отчет по внебюджетным слушателям (по зачислению)'''
    student_certificate = student_certificateCursor(context)
    speciality = specialityCursor(context)
    vw_course = vw_courseCursor(context)
    course_edu_form = course_edu_formCursor(context)
    education_form = education_formCursor(context)
    edu_organization = edu_organizationCursor(context)
    course_cycle = course_cycleCursor(context)
    speciality.setRange('education_level', 4)
    speciality.orderBy('name')
    sdf = SimpleDateFormat('dd.MM.yyyy')
    edu_organization.get(edu_org_id)
    data = {"schema":
            {"speciality":
             [],
             'date_from':sdf.format(date_from),
             'date_to':sdf.format(date_to),
             'edu_org_name':edu_organization.shortname
            }
        }
    
    count_spec = 1
    for speciality in speciality.iterate():
        count_program = 1
        spec_dict = {"name":speciality.name,
                     "number":count_spec,
                     "program":''
                     }
        program_list = []
        vw_course.setRange('speciality_id',speciality.uid)
        vw_course.setRange('edu_organization_id', edu_org_id)
        for course in vw_course.iterate():
            course_cycle.setRange('course_id', course.uid)
            course_cycle.setRange('start_date', date_from, date_to)
            
            if course_cycle.count() > 0:
                count_cycle = 1
                program_dict = {'number':'%d.%d' % (count_spec,count_program),
                                'name':course.name,
                                'type':u'ПК',
                                'course':[]
                                }
                for course_cycle in course_cycle.iterate():
                    student_certificate.setRange('cycle_id', course_cycle.uid)
                    student_certificate.setRange('status', 'dep')
                    dep_count = student_certificate.count()
                    student_certificate.setRange('status', 'suc')
                    suc_count = student_certificate.count()
                    education_form.get(course_cycle.education_form_id)
                    cycle_dict = {'number':'%d.%d.%d' % (count_spec, count_program, count_cycle),
                                  'internship':u'Да' if course.internship else u'Нет',
                                  'simulation':u'Да' if course.osk else u'Нет',
                                  'dot_eo':u'Да' if course_cycle.dot_and_eo else u'Нет',
                                  'zet':course.course_hours if course.course_hours else '',
                                  'zet_internship':course.internship_hours if course.internship_hours else '',
                                  'zet_simulation':course.osk_hours if course.osk_hours else '',
                                  'edu_cost':course.edu_cost,
                                  'start_date': sdf.format(course_cycle.start_date),
                                  'end_date': sdf.format(course_cycle.end_date),
                                  'edu_form':education_form.name,
                                  'dep_count': dep_count,
                                  'suc_count': suc_count,
                                  'sum': (dep_count + suc_count) * course.edu_cost
                                  }
                    program_dict['course'].append(cycle_dict)
                    count_cycle += 1
                count_program += 1
                program_list.append(program_dict)
        spec_dict['program'] = program_list
        if program_list:
            count_spec += 1
            data['schema']['speciality'].append(spec_dict)


    xmlData = XMLJSONConverter.jsonToXml(json.dumps(data))
    return (u'<?xml version="1.0" encoding="UTF-8"?> %s' % xmlData)



def printToFlute(context, params):
    u'''Функция для подготовки печатных форм через флейту.
    '''
    sdf = SimpleDateFormat('yyyy-MM-dd')

    arg_dict = json.loads(params.params)
    data = reportData(context, arg_dict['edu_org_id'], sdf.parse(arg_dict['date_from']), sdf.parse(arg_dict['date_to']))
    # печатаем в resultstream флейты
    printToExcel(data, 'studentReport.xls', 'studentReport.xml', params.resultstream)

