# coding: utf-8
'''
Created on 02.02.2016

@author: m.prudyvus
'''
from java.util import ArrayList
import json

from edu._edu_orm import vw_module_courseCursor
from nci._nci_orm import edu_organizationCursor, org_addressCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO


def moduleCourseList(context, main=None, add=None, filterinfo=None, session=None, params=None,
               curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''Список курсов'''
    vw_module_course = vw_module_courseCursor(context)
    edu_organization = edu_organizationCursor(context)
    org_address = org_addressCursor(context)

    if params:
        filter_data = json.loads(XMLJSONConverter.xmlToJson(params))["schema"]["filter"]

        if not isinstance(filter_data, list):
            filter_data = [filter_data]

        for filter_item in filter_data:
            if filter_item.get("edu_org_id"):
                vw_module_course.setRange("course_edu_org_id", filter_item["edu_org_id"])
            elif filter_item.get("module_id"):
                vw_module_course.setRange("module_id", filter_item["module_id"])

    vw_module_course.orderBy('course_name')
    vw_module_course.setFilter('course_name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    vw_module_course.limit(firstRecord, recordCount)

    recordList = ArrayList()
    for vw_module_course in vw_module_course.iterate():
        record = DataRecord()
        edu_organization.get(vw_module_course.course_edu_org_id)

        record.id = str(vw_module_course.course_id)
        record.name = u'%s (%d часов) - %s' % (vw_module_course.course_name,
                                               vw_module_course.course_hours,
                                               vw_module_course.course_edu_org_name)
        record.addParameter("edu_org_id", edu_organization.uid)
        record.addParameter("edu_org_name", edu_organization.shortname or edu_organization.name)

        if org_address.tryGet(edu_organization.address_id):
            record.addParameter("region_id", org_address.region_id)
            record.addParameter("region_name", org_address.region_name)

            record.addParameter("city_id", org_address.city_id)
            record.addParameter("city_name", org_address.city_name)

        recordList.add(record)

    return ResultSelectorData(recordList, 0)

def moduleCourseCount(context, main=None, add=None, filterinfo=None, session=None, params=None,
                     curValue=None, startsWith=None):
    '''Счетчик курсов'''
    vw_module_course = vw_module_courseCursor(context)

    if params:
        filter_data = json.loads(XMLJSONConverter.xmlToJson(params))["schema"]["filter"]

        if not isinstance(filter_data, list):
            filter_data = [filter_data]

        for filter_item in filter_data:
            if filter_item.get("edu_org_id"):
                vw_module_course.setRange("course_edu_org_id", filter_item["edu_org_id"])
            elif filter_item.get("module_id"):
                vw_module_course.setRange("module_id", filter_item["module_id"])

    vw_module_course.orderBy('course_name')
    vw_module_course.setFilter('course_name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))

    count = vw_module_course.count()

    return ResultSelectorData(None, count)
