# coding: utf-8
'''
Created on 09.01.2018 г.

@author: dgulyakin
'''
from __builtin__ import None
import json
from datetime import datetime
from java.text import SimpleDateFormat
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from umk._umk_orm import specialityCursor
try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO

from edu._edu_orm import educational_groupCursor


def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка создания группы тестирования'''    
    speciality_id = main
    speciality_name = u''
    speciality = specialityCursor(context)
    if speciality.tryGet(speciality_id):
        speciality_name = speciality.name
    
    xformsdata = {"schema": {
                    "@xmlns":"", 
                    "speciality_id": speciality_id,
                    "speciality_name": speciality_name,
                    "kafedra_name": "",
                    "stud_spec_name": "",
                    "edu_level_name": "",
                    "control_date": SimpleDateFormat("yyyy-MM-dd").format(datetime.now()),
                    "control_time": u'09:00'}}
    
    xformssettings = {"properties": {
                        "event": [
                            {"@name":"single_click",
                             "@linkId": "1",
                             "action": {
                                '#sorted': [
                                    {"main_context": "current"},
                                    {"datapanel": {"@type": "current",
                                        "@tab": "current",
                                        "element": {
                                            "@id":"testGroupsGrid",
                                            "add_context": add}}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))
    
    
def cardDataSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение глобальных параметров'''
    data_dict = json.loads(xformsdata)["schema"]
    speciality_id = data_dict['speciality_id']
    kafedra_name = data_dict['kafedra_name']
    stud_spec_name = data_dict['stud_spec_name']
    edu_level_name = data_dict['edu_level_name']
    
    control_date = datetime.strptime(data_dict['control_date'], "%Y-%m-%d")
    group_name = u'{}, {} {}'.format(data_dict['speciality_name'], SimpleDateFormat("dd.MM.yyyy").format(control_date), data_dict['control_time'])
    
    groupCur = educational_groupCursor(context)    
    groupCur.setRange('speciality', speciality_id)
    groupCur.setRange('group_name', group_name)
    if groupCur.tryFirst():
        context.warning(u'Группа "{}" уже существует'.format(group_name))
    else:
        groupCur.clear()
        groupCur.speciality = speciality_id
        groupCur.group_name = group_name
        groupCur.create_date = datetime.now()
        groupCur.control_date = control_date
        groupCur.kafedra_name = kafedra_name
        groupCur.stud_spec_name = stud_spec_name
        groupCur.edu_level_name = edu_level_name
        groupCur.insert()

