# coding: utf-8

import json

from com.jayway.jsonpath import JsonPath
from nci._nci_orm import person_edu_organizationCursor, edu_organizationCursor
from nci.functions.persons import getPersonIdBySid
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from medstaff._medstaff_orm import student_certificateCursor

try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO


def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка заявки на цикл аккредитации'''


    xformsdata = {
        "schema": {
            "@xmlns": "",
            "record": {
                "uid": "",
                "edu_organization_id": "",
                "edu_organization_name":"",
                "course_id": "",
                "course_name": "",
                "edu_organization": [],
                "cycle_id":"",
                "cycle_name":"",
                "type":''
                        }
        }
    }

    sid = JsonPath.read(session, "$.sessioncontext.sid")
    # определяем идентификатор ФЛ по sid
    person_id = getPersonIdBySid(context, sid)
    # определяем обр организацию данного ФЛ
    if main == 'edu':
        xformsdata['schema']['record']['type'] = 'edu'
        edu_organization = edu_organizationCursor(context)
        person_edu_organization = person_edu_organizationCursor(context)
        person_edu_organization.setRange('person_id', person_id)
        person_edu_organization.setRange('role', 'staff')
        for person_edu_organization in person_edu_organization.iterate():
            edu_organization.get(person_edu_organization.edu_organization_id)
            xformsdata['schema']['record']['edu_organization'].append({
                '@label': edu_organization.shortname if edu_organization.shortname else edu_organization.name,
                '@value': person_edu_organization.edu_organization_id})
        if len(xformsdata['schema']['record']['edu_organization']) == 1:
            # просто берем первую
            xformsdata['schema']['record']['edu_organization_id'] = \
                xformsdata['schema']['record']['edu_organization'][0]['@value']
        elif len(xformsdata['schema']['record']['edu_organization']) > 1:
            xformsdata['schema']['record']['edu_organization'].insert(0, {
                '@label': 'Все организации данного пользователя',
                '@value': '-'})
            xformsdata['schema']['record']['edu_organization_id'] = '-'
    else:
        xformsdata['schema']['record']['type'] = 'method'

    xformssettings = {
        "properties": {
            "event": [{
                    "@name": "single_click",
                    "@linkId": "1",
                    "action": {
                        "@keep_user_settings": "false",
                        '#sorted': [
                            {"main_context": "current"},
                            {"datapanel": {
                                "@type": "current",
                                "@tab": "current",
                                "element": {
                                    "@id": "certificationMethodGrid",
                                    "add_context": ""
                                }
                            }}]
                    }
                }
            ]
        }
    }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    session = json.loads(session)['sessioncontext']

    data = json.loads(xformsdata)['schema']['record']
    cycle_id = data['cycle_id']
    
    student_certificate = student_certificateCursor(context)
    student_certificate.setRange('cycle_id',cycle_id)
    student_certificate.setRange('status','not_observed')
    for student_certificate in student_certificate.iterate():
        student_certificate.status = 'not_use'
        student_certificate.update()