# coding: utf-8

from java.text import SimpleDateFormat
import json

from com.jayway.jsonpath import JsonPath
from nci.functions.persons import getPersonIdBySid
from security.functions import userHasPermission
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from nci._nci_orm import person_edu_organizationCursor, edu_organizationCursor



try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.app.api import MessageType, UserMessage
except:
    from ru.curs.celesta.showcase import JythonDTO



def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка цикла аккредитации'''
    if context.getData().get(elementId,''):
        xformsdata = context.getData()[elementId]
    else:
        
        bool_values = [{"label":u'Да',
                "value":'true'},
               {"label":u'Нет',
                "value":'false'},
               {"label": u'Все',
                "value": '-'}
               ]
        
        status_values = [
                         {"label": u"Формируется",
                          "value": 0
                          },
                         {"label": u"На доработку",
                          "value": 1
                          },
                         {"label": u"На проверке",
                          "value": 2
                          },
                         {"label": u"Утвержден(-а)",
                          "value": 3
                          },
                         {"label": u"Сформирован(-а)",
                          "value": 4
                          },
                         {"label": u"В архиве",
                          "value": 5
                          },
                         {"label": u"Отменен(-а)",
                          "value": 6
                          },
                         {"label": u"Отклонен(-а)",
                          "value": 7
                          },
                         {
                          "label": u"Все",
                          "value": "-"}
                         ]
        
        xformsdata = {"schema":
                          {"@xmlns": "",
                           "record":
                                {
                               'edu_organization_id':'',
                               'edu_organization_name':'',
                               'edu_abbreviation':'',
                               'speciality_id':'',
                               'status_id':'',
                               'speciality_name':'',
                               'name':'',
                               'dot_and_eo':'-',
                               'certificate':'-',
                               'simulation':'-',
                               'intern':'-',
                               'bool_values':bool_values,
                               'status_values':status_values,
                               'sim_hours_from':'',
                               'sim_hours_to':'',
                               'hours_from': '',
                               'hours_to': '',
                               'intern_hours_from':'',
                               'intern_hours_to':'',
                               'dev_year': '',
                               'hasPermission': '',
                               "edu_organization": []
                                }
                            }
                          }
    
        edu_org = edu_organizationCursor(context)
    
        sid = JsonPath.read(session, "$.sessioncontext.sid")
        # определяем идентификатор ФЛ по sid
        person_id = getPersonIdBySid(context, sid)
        hasPermission = "true"
        if not userHasPermission(context, sid, "allEduOrgCourse"):
            hasPermission = "false"
            person_org = person_edu_organizationCursor(context)
            edu_organization = edu_organizationCursor(context)
            person_org.setRange("person_id", person_id)
            if not person_org.count():
                context.error(u"Обратитесь к администратору для приписывания к образовательной организации")
            person_org.setRange('role', 'staff')
            for person_org in person_org.iterate():
                edu_organization.get(person_org.edu_organization_id)
                xformsdata['schema']['record']['edu_organization'].append({
                    '@label': edu_organization.shortname if edu_organization.shortname else edu_organization.name,
                    '@value': person_org.edu_organization_id})
            if len(xformsdata['schema']['record']['edu_organization']) == 1:
                # просто берем первую
                xformsdata['schema']['record']['edu_organization_id'] = \
                    xformsdata['schema']['record']['edu_organization'][0]['@value']
            elif len(xformsdata['schema']['record']['edu_organization']) > 1:
                xformsdata['schema']['record']['edu_organization'].insert(0, {
                    '@label': 'Все организации данного пользователя',
                    '@value': '-'})
                xformsdata['schema']['record']['edu_organization_id'] = '-'
              
        xformsdata['schema']['record']['hasPermission'] = hasPermission
    



    xformssettings = {"properties":{
#                                     "action":{"main_context": "current",
#                                               "datapanel": {"@type": "current",
#                                                             "@tab": "current",
#                                                             "element": {"@id":"courseGrid",
#                                                                         "add_context": "current"}
#                                                             }
#                                               },
                                    "event":[{"@name":"single_click",
                                              "@linkId": "1",
                                              "action":{
                                                '#sorted': [
                                                    {"main_context": "current"},
                                                    {"datapanel": {"@type": "current",
                                                                      "@tab": "current",
                                                                      "element": [{"@id":"courseGrid",
                                                                                  "add_context": "current"},
#                                                                                     {"@id":"courseCycleGrid",
#                                                                                     "add_context": "hide"}
                                                                                 ]                                                                      
                                                                       }}]
                                                         }
                                              }]
                                    }
                      }

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))


def cardSave(context, main=None, add=None, filterinfo=None,
             session=None, elementId=None, xformsdata=None):
    context.getData()[elementId] = json.loads(xformsdata)
    
