# coding: utf-8
'''
Created on 13 нояб. 2017 г.

@author: dgulyakin
'''
import json
from uuid import uuid4
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from nci._nci_orm import test_matrixCursor
from edu._edu_orm import educational_groupCursor, edu_group_personsCursor
from nci.grid.personGrid import createPersonAccount
from __builtin__ import None
from umk._umk_orm import specialityCursor
from qt._qt_orm import QtiPackageAttributeCursor
from qt.functions import createTestingVariantAssign, generateVariant,\
    setTestTimeByParam
from nci.functions.persons import getPersonIdBySid
from common.numbersseries.getNextNo import getSeriesParams
try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO

def cardData(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    u'''Карточка глобальных параметров'''    
    xformsdata = {"schema": {"@xmlns":"", "#sorted": [
        {"speciality": main}, 
        {"test_matrix_variant": {"@id": "", "#text": ""}},
        {"params": ''}]}}
    
    xformssettings = {"properties": {
                        "event": [
                            {"@name":"single_click",
                             "@linkId": "1",
                             "action": {
                                '#sorted': [
                                    {'navigator': {
                                        '@element': 'group_{}'.format(add),
                                        '@refresh': 'true'}}]}}]}}

    return JythonDTO(XMLJSONConverter.jsonToXml(json.dumps(xformsdata)),
                     XMLJSONConverter.jsonToXml(json.dumps(xformssettings)))
    
    
def cardDataSave(context, main=None, add=None, filterinfo=None, session=None, elementId=None, xformsdata=None):
    u'''Сохранение глобальных параметров'''
    edu_groupCur = educational_groupCursor(context)
    if edu_groupCur.tryGet(add):
        data = json.loads(xformsdata)["schema"]
#         quantity_questions = data['QUANTITY_QUESTIONS']['value']
#         test_matrix_variant = data['test_matrix_variant']['@id']
#         
#         test_matrixCur = test_matrixCursor(context)
#         if test_matrixCur.tryGet(test_matrix_variant):
#             quantity_questions = test_matrixCur.question_count
#         
#         test_params = {'NoRandom': 0,
#                       'TimeTest': data['TEST_TIME']['value'],
#                       'QuantityQuestions': quantity_questions,
#                       'Percent3': data['PERCENT_3']['value'],
#                       'Percent4': data['PERCENT_4']['value'],
#                       'Percent5': data['PERCENT_5']['value'],
#                       'NoProtocol': data['SHOW_PROTOCOL']['value'],
#                       'NoSelfTesting': 1}
        test_params = {}
        for key, value in data["params"].items():
            test_params[key] = value['value']
        
        edu_groupCur.params = json.dumps(test_params)
        edu_groupCur.status = 30        
        edu_groupCur.package_id = data['test_matrix_variant']['@id']
        edu_groupCur.update()
        generatePersonAccounts(context, add)
    else:
        context.error(u'Неизвестная группа')
        
def getSpecialityQtyPackage(context, speciality_id):
    package_id = None
    specialityCur = specialityCursor(context)
    if specialityCur.tryGet(speciality_id):
        speciality_name = specialityCur.name
        attributeCur = QtiPackageAttributeCursor(context)
        attributeCur.setRange('AttributeName', u'Специальность')
        attributeCur.setRange('AttributeValue', speciality_name)
        if attributeCur.tryFirst():
            package_id = attributeCur.PackageID
            
        attributeCur.close()
            
    specialityCur.close()
        
    return package_id


def generatePersonAccounts(context, group_id):
    u'''Генерация аккаунтов для  проходящих тестирование'''
    params = getSeriesParams(context, 'persons')
    prefix = params['prefix']
    postfix = params['postfix']
    
    person_cur = edu_group_personsCursor(context)
    person_cur.setRange('group_id', group_id)
    for person in person_cur.iterate():
        login = person.person_id
        login = login.replace(prefix, '').replace(postfix, '')
        password = login
        createPersonAccount(context, None, None, None, None, person.person_id, login, password, False)
 
 
def getPersonTestLink(context, sid):
    person_id = getPersonIdBySid(context, sid)
    modeId = 'test'
    package_id = ''
    
    groupCur = educational_groupCursor(context)
    group_personsCur = edu_group_personsCursor(context)
    group_personsCur.setRange('person_id', person_id)
    links = dict()
    for person_group in group_personsCur.iterate():
        group_id = person_group.group_id
        variant_id = unicode(uuid4())
        if groupCur.tryGet(group_id) and groupCur.status==30:
            package_id = groupCur.package_id
            if group_personsCur.variant_id:
                variant_id = group_personsCur.variant_id
            else:
                group_personsCur.variant_id = variant_id
                group_personsCur.update()
                
                params = json.loads(groupCur.params)
                
                createTestingVariantAssign(context, variant_id, package_id, sid, person_id, params, group_id)
                generateVariant(context, package_id, variant_id, debugFlag=False)                
                setTestTimeByParam(context, variant_id)
                
            links[groupCur.group_name] = "?userdata=qtAuthor&mode=%s&package=%s&param=%s" % (modeId, package_id, variant_id)
        
    group_personsCur.close()
    groupCur.close()
    return links


def getStudentTestLink(context, main=None, add=None, filterinfo=None, session=None, data=None):
    ss = json.loads(session)['sessioncontext']
    sid = ss['sid']
    link = {"schema": {"@xmlns":"", "link": ''}}
    
    person_data = json.loads(data)["schema"]
    
    person_id = person_data['student']['@id']
    group_id = person_data['group']['@id']
    modeId = 'test'
    package_id = ''
    new_variant = False
    
    groupCur = educational_groupCursor(context)
    if groupCur.tryGet(group_id) and groupCur.status==30:
        package_id = groupCur.package_id
        params = json.loads(groupCur.params)
    groupCur.close()
    
    group_personsCur = edu_group_personsCursor(context)
    group_personsCur.setRange('group_id', group_id)
    group_personsCur.setRange('person_id', person_id)

    if group_personsCur.tryFirst():
        if group_personsCur.variant_id:
            variant_id = group_personsCur.variant_id
        else:
            new_variant = True
            variant_id = unicode(uuid4())
#             link["schema"]["link"]["@variant_id"] = variant_id
            group_personsCur.variant_id = variant_id
            group_personsCur.update()

    group_personsCur.close()
    
    if package_id and params:         
        if new_variant:       
            createTestingVariantAssign(context, variant_id, package_id, sid, person_id, params, group_id)
            generateVariant(context, package_id, variant_id, debugFlag=False)    
            setTestTimeByParam(context, variant_id)
                
        link["schema"]["link"] = "?userdata=qtAuthor&mode=%s&package=%s&param=%s" % (modeId, package_id, variant_id)
    
    return XMLJSONConverter.jsonToXml(json.dumps(link))


def getTestParams(context, main=None, add=None, filterinfo=None, session=None, data=None):
    u'''Получение параметров конфигурации теста'''
    data_json = json.loads(data)
    
    test_matrixCur = test_matrixCursor(context)
    if test_matrixCur.tryGet(data_json['schema']['test_matrix_variant']['@id']):
        data_json['schema']['params'] = json.loads(test_matrixCur.params)
    test_matrixCur.close()
    return XMLJSONConverter.jsonToXml(json.dumps(data_json))
